#!/usr/bin/env python
# -*- coding: utf-8 -*-
""" Handles contacts integration for fMMS

@author: Nick Leppänen Larsson <frals@frals.se>
@license: GNU GPL
"""
import evolution
import gtk
	
class ContactHandler:
	
	
	""" wouldnt mind some nice patches against this """
	def __init__(self):
		self.ab = evolution.ebook.open_addressbook("default")
		self.contacts = self.ab.get_all_contacts()
		self.phonedict = {}
		for c in self.contacts:
			#print c.get_name(), c.get_property('mobile-phone')
			#print c.get_property('other-phone')
			mb = c.get_property('mobile-phone')
			cp = c.get_property('other-phone')
			self.phonedict[c.get_name()] = (mb, cp)
	
	""" takes a number on international format (ie +46730111111) """
	def get_name_from_number(self, number):
		### do some voodoo here
		# ugly way of removing country code since this
		# can be 2 or 3 chars we remove 4 just in case
		# 3 and the + char = 4
		numberstrip = number[4:-1]
		for person in self.phonedict:	
			for cbnr in self.phonedict[person]:
				if cbnr != None:
					cbnr = cbnr.replace(" ", "")
					cbnr = cbnr.lstrip('0')
					if cbnr == number or numberstrip.endswith(cbnr) or number.endswith(cbnr):
						return person
					
		return None
	
	def get_photo_from_name(self, pname, imgsize):
		res = self.ab.search(pname)
		### do some nice stuff here
		#l = [x.get_name() for x in res]
		#print "search for:", pname, "gave res: ", l
		if res != None:
			img = res[0].get_photo(imgsize)
			if img == None:
				vcardlist = res[0].get_vcard_string().replace('\r', '').split('\n') # vcard for first result
				for line in vcardlist:
					if line.startswith("PHOTO;VALUE=uri:file://"):
						imgstr = line.replace("PHOTO;VALUE=uri:file://", "")
						img = gtk.gdk.pixbuf_new_from_file(imgstr)
						height = img.get_height()
						if height != imgsize:
							newheight = imgsize
							newwidth = int(newheight * img.get_width() / height)
							#print "h:", height, "w:", img.get_width()
							#print "newh:", newheight, "neww:", newwidth
							img = img.scale_simple(newwidth, newheight, gtk.gdk.INTERP_BILINEAR)
			return img
		else:
			return None
		
		
if __name__ == '__main__':
	cb = ContactHandler()
	phonedict = {}
	
	#print cb.get_name_from_number('+46')
	
	"""r = cb.ab.search('') # Returns List of results
	print r
	l = [x.get_name() for x in r] # list of results
	u = r[0].get_name() # name of the first result
	vcardlist = r[0].get_vcard_string().replace('\r', '').split('\n') # vcard for first result
	for line in vcardlist:
		if line.startswith("PHOTO;VALUE=uri:file://"):
			print line.replace("PHOTO;VALUE=uri:file://", "")
			
	#print r[0].get_photo(64)"""
